#!/usr/bin/perl
#
# Nagios Webmin Module
#
# Copyright (C) 2005 John Campbell/Rawlings Computers & Communications
#                    john@rawcomm.net
#                    http://www.rawcomm.net/nagios-admin
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

require 'nagios-lib.pl';


# Do common initialization and get common routines
#
# Lets check and make sure the module was configured with defaults during installation,
# or that settings have been previously saved, otherwise, lets dump them to the config screen
($Nagios_bin) = $config{'Nagios_path'} =~ /^(\S+)/;  # Strip any options - note this will choke if th
if ((! -r $Nagios_bin) || (! -r $config{'Nagios_config'})) {
   # Check if they can change config first!
   if ($access{'noconfig'}) {
      $whatfailed = $text{'error_confchk'};
      &nagios_error($text{'error_config'});
   } else {
      &redirect("/config.cgi?nagios-admin");  # Redirect user to config section
      exit;
   }
}

#Send the header
&header("Nagios Administration", "", undef, 1, 1, 0,
   &help_search_link("nagios", "man", "doc", "google"));
 print "<hr>\n";

ReadParse();

if ($in{action} eq "")
{
	print <<ENDHTML;
<p>Welcome to the Nagios Configuration utility. Here you can add and edit the config files in Nagios.
<hr>
Nagios Process:<b>
ENDHTML

{
print `$config{Nagios_proc}` 
}
print <<ENDHTML;
</b>
<form action="edit_cfg.cgi" method="post">
<input type="hidden" name="action" value="editcfgs">
<br>
Select the Config file to edit:
<p><select name="configs" size=12>
ENDHTML

        foreach my $files (`ls $config{Nagios_config}`)
        {
                     print "<option>$files"
        }

        print <<ENDHTML;
</select>
<p><input type="submit" value="Edit Configuration File"><p>
</form>
<hr>
<form action="index.cgi" method="post">
<input type="hidden" name="action" value="adduser">
Add a User to Access Nagios Web<br><br>
Username: <input type="text" name="un" ><br>
Password: &nbsp<input type="password" name="pw"><br>
<input type="submit" value="Add User">
</form>
<hr>
<form action="test.cgi" method="post">
<input type="hidden" name="action" value="test">
<p>Test Nagios Configuration - Output is stored in test.nag</p>
<input type="submit" value="Test Config">
</form>
<hr>
<form action="index.cgi" method="post">
<input type="hidden" name="action" value="stop">
Stop Nagios &nbsp&nbsp&nbsp&nbsp
<input type="submit" value="Stop">
</form>
<br>
<form action="index.cgi" method="post">
<input type="hidden" name="action" value="start">
Start Nagios &nbsp&nbsp&nbsp
<input type="submit" value="Start">
</form>
<br>
ENDHTML

# <form action="index.cgi" method="post">
# <input type="hidden" name="action" value="restart">
# Restart Nagios
# <input type="submit" value="Restart">
# </form>
# <hr>
# ENDHTML

print "<p>";
footer("index.cgi", "Nagios Configurations System");
exit 0;

}
elsif ($in{action} eq "adduser")
{
        print `htpasswd -b $config{Nagios_config}/htpasswd.users $in{un} $in{pw}`;
        print "<p> The $in{un} has been added";
}
elsif ($in{action} eq "stop")
{
        print `$config{'Nagios_rc'} stop`;
	print "<p> The Nagios Process has been Stopped";
}
elsif ($in{action} eq "start")
{
        print `$config{'Nagios_rc'} start`;
        print "<p> The Nagios Process has been Started";
}
# Enable this functio with care - this sometimes creates additional Processes
#elsif ($in{action} eq "restart")
#{
#        print `$config{Nagios_rc}/nagios stop`;
#	print `$config{Nagios_rc}/nagios start`;
#        print "<p> The Nagios Process has been Restarted";
#}


print "<p>";
footer("index.cgi", "Nagios Configuration");
